


joy1            = $00
joy1old         = $01

count_lo        = $04
count_hi        = $05
addr_lo         = $06
addr_hi         = $07
v2001           = $08
test            = $09
oldval          = $0A

sync            = $0B
anim_count      = $0C
player_ani      = $0D

food_speed_count        = $0E
random1         = $0F
random2         = $10
random3         = $11
random4         = $12
foodrow         = $13
row             = $14
in2006_lo       = $15
in2006_hi       = $16
quadro          = $17
food_velocity   = $18
comestible_index        = $20   ; uses $20,$30,$40,$50,$60,...
comestible_velocities   = $21   ; uses $21,$31,$41,$51,$61,...
comestible_veloc_hi     = $22   ; uses $22,$32,..
comestible_lowbytes     = $23   ; uses $23,$33,..


topscore        = $700
meltmem         = $B0

noclear         = $BB
score1          = $BC
scorething      = $BD
extra_checker   = $BE
melttime        = $BF

food_amount     = $C0
food_index      = $C1
generation_time = $C2
generation_count        = $C3
curr_level      = $C4
temp_lo         = $C5
temp_hi         = $C6
next_comestible = $C7
player_y_lo     = $C8
player_x_lo     = $C9
tiletype        = $CA
level_counter   = $CB
scroll_v        = $CC
lives           = $CD
melt            = $CE

score           = $D0
pal             = $E0

a_button = 128          ; joystick stuff
b_button = 64
select_button = 32
start_button = 16
up_button = 8
down_button = 4
left_button = 2
right_button = 1


.segment "DATA"
sprites: .res $100


;-------------------------------------
.macro  inc16   addr            ; increment 16bit value
.local label                    ;  regs : none
		inc     addr
		bne     label
		inc     addr+1
	label:
.endmacro
;-------------------------------------

.macpack longbranch


.segment "CODE"

.segment "MINIGAME"

.include "ntdec.s"

;grafx:  .incbin "blank.chr"
;
;
;;-------------------------------------
;rle_encode:                            ; RLE encoder, 7-12-2001
;        ldx #0
;        ldy #0
;
;        lda #>grafx
;        sta addr_hi
;        lda #<grafx
;        sta addr_lo
;        lda #$03
;        sta count_hi
;        lda #0
;        sta count_lo
;next_byte:
;        ldy #0
;        lda (addr_lo), y
;match:
;        iny
;        cpy #$FF
;        beq too_much
;        cmp (addr_lo), y
;        beq match
;
;        cpy #1
;        beq no_match
;        cpy #2
;        beq no_match
;        cpy #3
;        beq no_match
;too_much:
;        pha
;        tya
;        pha
;        lda #$7D        ; safe byte
;        ldy #0
;        sta (count_lo), y       ; safe byte
;        inc16 count_lo
;        pla
;        sta (count_lo), y       ; # of repeats
;
;        clc
;        adc addr_lo
;        sta addr_lo
;        lda addr_hi
;        adc #0
;        sta addr_hi
;
;        inc16 count_lo
;        pla
;        sta (count_lo), y       ; value to repeat
;        inc16 count_lo
;
;        jmp checkifdone
;
;no_match:
;        ldy #0
;        sta (count_lo), y
;        inc16 count_lo
;        inc16 addr_lo
;
;checkifdone:
;        lda addr_hi
;        cmp #$8A
;        bne not_done
;        lda addr_lo
;        cmp #$00
;        bne not_done
;rledone:
;        jmp rledone
;not_done:
;        jmp next_byte
;;-------------------------------------
;
;



start:
        sei
        cld

        ldx #$FF
        txs

@wait:
	lda $2002
	bpl @wait
@wait2:
	lda $2002
	bpl @wait2

        inx
        txa

        sta $2000
        sta $2001
        sta $4015

        sta addr_lo
        sta addr_hi

        lda noclear
        cmp #$7D
        bne memclear
        ldx #6
        bne momo
memclear:
        ldx #8
momo:
        lda #0
        tay
clear_ram:
        sta (addr_lo),y
        iny
        bne clear_ram
        inc addr_hi
        dex
        bne clear_ram

        lda #$7D
        sta noclear

        ldx #16
        lda #0
:
        sta score-1,x
        dex
        bne :-


        lda #$20
        sta in2006_lo
        lda #$06
        sta in2006_hi

        stx $2006
        stx $2006

        tya

        ldy #$40
        sty generation_time     ; init something
clear_vram:
        sta $2007
        dex
        bne clear_vram
        dey
        bne clear_vram

;***********
;        jmp rle_encode
;***********


;-------------------------------------

;        sty $2006
        lda #$01
        sta $2006
        sty $2006

        lda #>rnc_graphics
        sta addr_hi
        lda #<rnc_graphics
        sta addr_lo

        ldx #8
:
        lda (addr_lo),y
        sta $2007
        iny
        bne :-
        inc addr_hi
        dex
        bne :-

        lda #>packed_font
        sta addr_hi
        lda #<packed_font
        sta addr_lo

:
        sty temp_lo
        jsr bit_unpack
        ldy temp_lo
        jsr bit_unpack
        tya
        bne :-

                
        lda #$28
        sta $2006
        lda #0
        sta $2006
        lda #>back
        sta addr_hi
        lda #<back
        sta addr_lo
        lda #0
        jsr NT_decode

        lda #$30
        sta pal+13+16
        lda #$0F
        sta pal+15

        lda #$00
        sta scroll_v

        lda #%0001100
        sta $2001
;        sta v2001
        lda #$80
        sta $2000


titleloop:
        lda sync
        beq titleloop
        lda #0
        sta sync

        inc scroll_v
        lda scroll_v
        cmp #$E0
        bne titleloop

        ldy #30
:
        lda sync
        beq :-
        lda #0
        sta sync
        dey
        bne :-

        ldx #$C0
:
        lda sync
        beq :-
        lda #0
        sta sync
        inc pal+13+16
        dex
        bne :-

        lda #$FF
:
        sta meltmem,x
        inx
        cpx #8
        bne :-

        lda #64
        sta melttime
        inc melt

meltloop:
        ldy #2
:
        lda sync
        beq :-
        lda #0
        sta sync
        inc pal+13+16
        dey
        bne :-

        lda meltmem-1,x
        beq @itszero
        lsr
        sta meltmem-1,x
        jmp meltloop

@itszero:
        dex
        bne meltloop


        inc melt

        lda #0
        sta $2000
;        sta v2001
        sta $2001
        sta scroll_v


        lda #$0F
        sta $4015


;-------------------------------------




        ldy #$16
        ldx #$20
        stx $2006
        lda #$A0
        sta $2006
load_top_bar:
        sty $2007
        dex
        bne load_top_bar

        lda #$23
        sta $2006
        ldx #$20
        stx $2006
load_bottom_bar:
        sty $2007
        dex
        bne load_bottom_bar


load_palette:
        lda palette,x
        sta pal,x
        sta pal+$10,x
        inx
        cpx #$10
        bne load_palette

        stx anim_count


        ldx #0
init_player:
        lda player,x
        sta $204,x
        inx
        cpx #8
        bne init_player

        lda #7
        sta curr_level

        lda #$90
        sta score
        sta topscore

        lda #$20
        sta $2006
        lda #$2D
        sta $2006

        lda #$AD
        sta $2007
        ldx #$A8
        stx $2007
        inx
        stx $2007

        ldx #0
        ldy #0
:
        lda lifedisplay,y
        sta $2E3,x
        iny
        inx
        inx
        inx
        inx
        cpx #32
        bne :-

        ldx #0
        lda #$19
:
        sta $2E0,x
        inx
        inx
        inx
        inx
        cpx #32
        bne :-


        lda #4
        sta lives
        sta random4
        sta random3
        sta random2
        sta random1
        jsr random_gen

        lda #0
        sta $2006
        sta $2006


        lda #$80
        sta $2000
        lda #%00011000
        sta $2001
;        sta v2001

:
        inc random4
        lda joy1
        beq :-

dead:
        ldy #0
        lda sync
        beq dead
        sty sync

        dec anim_count
        bne no_anim
        lda #4
        sta anim_count

        ldx player_ani
        lda munch,x
        sta $205
        sta $209
        inx
        cpx #8
        bne @no_reset
        sty player_ani
        beq no_anim     ; bra
@no_reset:
        stx player_ani
        
no_anim:

        lda #up_button
        and joy1
        beq not_up
        lda $204
        cmp #49
        bcc not_up

        lda player_y_lo
        sec
        sbc #196
        sta player_y_lo
        lda $204
        sbc #2
        sta $204
        clc
        adc #8
        sta $208

not_up:
        lda #down_button
        and joy1
        beq not_down
        lda $208
        cmp #190
        bcs not_down

        lda player_y_lo
        clc
        adc #196
        sta player_y_lo

        php
        lda $204
        adc #2
        sta $204

        clc
        adc #8
        sta $208


not_down:
        lda #left_button
        and joy1
        beq not_left
        lda $207
        beq not_left

        lda player_x_lo
        sec
        sbc #192
        sta player_x_lo
        lda $207
        sbc #1
        sta $207
        sta $20B


not_left:
        lda #right_button
        and joy1
        beq not_right
        lda $207
        cmp #$F8
        beq not_right

        lda player_x_lo
        clc
        adc #192
        sta player_x_lo
        lda $207
        adc #1
        sta $207
        sta $20B

not_right:

stopit:

max_food = 4

        lda food_amount
        cmp #max_food
        jeq no_generation

        lda generation_count
        clc
        adc generation_time
        sta generation_count
        jcc no_generation

:
        jsr random_gen
        cmp #16
        bcc :-
        lsr
        lsr
        sta generation_time

notsafe:
        lda food_index
        clc
        adc #$10
        cmp #max_food*$10
        bne :+
        lda #0
:
        sta food_index

        lda curr_level
        and #%00000110
        bne :+
        lda #$80
        bne @doit
:       lda #0
@doit:
        sta temp_lo

        jsr random_gen
        lsr
        and #%01111000
        clc
        adc temp_lo
        tay

        ldx food_index
        lda $241,x
        bne notsafe
        lda foodtypes,y
        sta $241,x
        lda foodtypes+1,y
        sta $242,x
        lda foodtypes+2,y
        sta $245,x
        lda foodtypes+3,y
        sta $246,x
        lda foodtypes+4,y
        sta $249,x
        lda foodtypes+5,y
        sta $24A,x
        lda foodtypes+6,y
        sta $24D,x
        lda foodtypes+7,y
        sta $24E,x

newnumber:
        jsr random_gen
        lsr
        lsr
        lsr
        lsr
        lsr
        cmp #6
        bcs newnumber

        
        ldy #0
:
        cmp comestible_index,y

        beq newnumber
        pha
        tya
        clc
        adc #$10
        tay
        pla
        cpy #max_food*$10
        bne :-

        ldx food_index
        sta comestible_index,x
        tay

        lda comestibles,y
        sta $240,x
        pha
        lda #$F7
        sta $243,x
        pla
        sta $244,x
        pha
        lda #$FF
        sta $247,x
        pla
        clc
        adc #8
        sta $248,x
        pha
        lda #$F7
        sta $24B,x
        pla
        sta $24C,x
        lda #$FF
        sta $24F,x


        jsr random_gen
        ldx curr_level
        beq fast_as_possible
:
        lsr
        dex
        bne :-

fast_as_possible:
        and #%00111111

        tax
        lda foodspeeds,x
        ldx food_index
        pha
        lda #0
        sta comestible_veloc_hi,x
        pla
        asl a
        rol comestible_veloc_hi,x
        asl a
        rol comestible_veloc_hi,x
        asl a
        rol comestible_veloc_hi,x
        sta comestible_velocities,x
        

no_generation:

        ldx #0
:
        lda comestible_lowbytes,x
        sec
        sbc comestible_velocities,x
        sta comestible_lowbytes,x
        lda $243,x
        sbc comestible_veloc_hi,x
        sta $243,x
        sta $24B,x
        clc
        adc #8
        sta $247,x
        sta $24F,x
        txa
        clc
        adc #$10
        tax
        cpx #max_food*$10
        bne :-


        ldx #0
        stx food_amount
@missed_food:
        stx temp_lo
        lda $241,x
        beq @nothing
        inc food_amount
        lda $247,x
        cmp #10
        bcs @nothing

;@bla:    jmp @bla

        lda #0
        ldy #4
:
        sta $241,x
        inx
        inx
        inx
        inx
        dey
        bne :-


@nothing:
        lda temp_lo
        clc
        adc #$10
        tax
        cpx #max_food*$10
        bne @missed_food


hit_detection:
        ldx #0
@hitloop:
        lda $241,x
        sta tiletype
        jeq @itsblank
        lda $243,x
        sec
        sbc #8
        cmp $207
        jcs @itsblank
        clc
        adc #24
        cmp $207
        jcc @itsblank

        lda $240,x
        sec
        sbc #15
        cmp $204
        jcs @itsblank
        clc
        adc #30
        cmp $204
        jcc @itsblank

        lda #0
        sta $241,x
        sta $245,x
        sta $249,x
        sta $24D,x

        stx temp_lo

        ldy #1
        lda tiletype
        cmp #$1F
        jeq @hurtit
        cmp #$24
        jeq @hurtit

        cmp #$17
        jeq @scoreit
        iny
        cmp #$1D
        jeq @scoreit
        iny
        iny
        cmp #$26
        jeq @scoreit
        iny
        iny
        cmp #$19
        jeq @scoreit
        iny
        iny
        iny
        iny
        cmp #$1B
        jeq @scoreit

        lda curr_level
        bne :+
        ldy #96
:
        iny
        iny
        iny
        iny

@scoreit:
        jsr do_scoring
        dey
        bne @scoreit

        lda score+5
        cmp extra_checker
        beq :+
        inc lives
        pha
        ldx #4
        ldy #4
        jsr play_sfx

        pla
:       sta extra_checker

        lda #$90
        sta score+1

        inc level_counter
        lda level_counter
        cmp #24
        bne :+
        lda #0
        sta level_counter
        lda curr_level
        beq :+
        dec curr_level
:
        ldx #0
        ldy #0
        jsr play_sfx

;@dieie:  jmp @dieie

;        ldx #2
;:
;        lda score,x
;        beq :+
;        inx
;        cpx #16
;        bne :-
;:
;        stx score1
;        ldx #2
;:
;        lda topscore,x
;        beq :+
;        inx
;        cpx #16
;        bne :-
;:
;;        stx score2
;
;        cpx score1
;        bcs @lowscore
;        bne @itshigh
;
;        ldx score1
;@checkit:
;        lda topscore,x
;        cmp score,x
;        bcc @lowscore
;        bne @itshigh
;        dex
;        bne @checkit

        ldx #16
@cmploop:
        dex
        beq @cmpend
        lda score-1,x
        cmp topscore-1,x
        beq @cmploop
@cmpend:
        bcc @lowscore

@itshigh:

        ldx #0
:
        lda score,x
        sta topscore,x
        inx
        cpx #16
        bne :-


@lowscore:
        
        jmp @skipstuff

@hurtit:
        ldy #$0C
        ldx #0
        jsr play_sfx

        ldx #10
        lda #%00011001
        sta $2001
;        sta v2001
:
        lda sync
        beq :-
        lda #0
        sta sync
        dex
        bne :-
        lda #%00011000
        sta $2001
;        sta v2001

        dec lives
        bne @alive

        lda #%11111000
        sta $2001
;        sta v2001

        ldy #120
:
        lda sync
        beq :-
        lda #0
        sta sync
        dey
        bne :-
        jmp start

@alive:

@skipstuff:

        ldx temp_lo
@itsblank:
        txa
        clc
        adc #$10
        tax
        cpx #max_food*$10
        jne @hitloop

        jmp dead



bit_unpack:
        ldx #8
:
        lda (addr_lo),y
        sta $2007
        iny
        dex
        bne :-
        rts

        
do_scoring:
        ldx #2
@scoreloop:
        inc score,x
        lda score,x
        cmp #$01        ; uninitialized?
        bne :+
        lda #$91
        sta score,x
        bne @end
:

        cmp #$9A
        bne :+
        lda #$90
        sta score,x
        inx
        bne @scoreloop
:
@end:

        rts



; player data

player: .byte $78,$11,$00,$30
        .byte $80,$11,$80,$30

        ;.byte $30,$80,$11,$80
        ;.byte $30,$00,$11,$78

munch:
        .byte $10,$11,$12,$13,$14,$13,$12,$11

comestibles:
        .byte   $30
        .byte   $48
        .byte   $60
        .byte   $78
        .byte   $90
        .byte   $A8


foodtypes:
        .byte   $17,$00,$17,$40,$18,$00,$18,$40         ; McFries
        .byte   $19,$01,$19,$41,$1A,$01,$1A,$41         ; orange?
        .byte   $1B,$00,$1C,$C0,$1C,$00,$1B,$C0         ; mystery food
        .byte   $1D,$02,$1D,$42,$1E,$02,$1E,$42         ; hamburger
        .byte   $20,$03,$20,$43,$21,$03,$21,$43         ; squeedo del tepton!
        .byte   $26,$00,$27,$00,$28,$00,$28,$40         ; a fishy
        .byte   $1F,$C3,$22,$03,$23,$03,$1F,$03         ; knife (barf)
        .byte   $24,$03,$25,$C3,$25,$03,$24,$C3         ; shuriken (barf)
        .byte   $17,$00,$17,$40,$18,$00,$18,$40         ; McFries
        .byte   $19,$00,$19,$40,$1A,$00,$1A,$40         ; orange?
        .byte   $1B,$01,$1C,$C1,$1C,$01,$1B,$C1         ; mystery food
        .byte   $1D,$02,$1D,$42,$1E,$02,$1E,$42         ; hamburger
        .byte   $20,$03,$20,$43,$21,$03,$21,$43         ; squeedo del tepton!
        .byte   $26,$01,$27,$01,$28,$01,$28,$41         ; a fishy
        .byte   $1F,$C3,$22,$03,$23,$03,$1F,$03         ; knife (barf)
        .byte   $24,$03,$25,$C3,$25,$03,$24,$C3         ; shuriken (barf)

        .byte   $17,$00,$17,$40,$18,$00,$18,$40         ; McFries
        .byte   $19,$01,$19,$41,$1A,$01,$1A,$41         ; orange?
        .byte   $1F,$C3,$22,$03,$23,$03,$1F,$03         ; knife (barf)
        .byte   $24,$03,$25,$C3,$25,$03,$24,$C3         ; shuriken (barf)
        .byte   $20,$03,$20,$43,$21,$03,$21,$43         ; squeedo del tepton!
        .byte   $26,$03,$27,$03,$28,$03,$28,$43         ; a fishy
        .byte   $1F,$C3,$22,$03,$23,$03,$1F,$03         ; knife (barf)
        .byte   $24,$03,$25,$C3,$25,$03,$24,$C3         ; shuriken (barf)
        .byte   $1F,$C3,$22,$03,$23,$03,$1F,$03         ; knife (barf)
        .byte   $24,$03,$25,$C3,$25,$03,$24,$C3         ; shuriken (barf)
        .byte   $1B,$02,$1C,$C2,$1C,$02,$1B,$C2         ; mystery food
        .byte   $1D,$02,$1D,$42,$1E,$02,$1E,$42         ; hamburger
        .byte   $20,$03,$20,$43,$21,$03,$21,$43         ; squeedo del tepton!
        .byte   $26,$00,$27,$00,$28,$00,$28,$40         ; a fishy
        .byte   $1F,$C3,$22,$03,$23,$03,$1F,$03         ; knife (barf)
        .byte   $24,$03,$25,$C3,$25,$03,$24,$C3         ; shuriken (barf)



foodspeeds:
        .byte   $40,$48,$50,$58,$60,$68,$70,$78
        .byte   $80,$84,$88,$8C,$90,$94,$98,$9C         ; level 2
        .byte   $A0,$A2,$A4,$A6,$A8,$AA,$AC,$AE         ; level 3
        .byte   $B0,$B2,$B4,$B6,$B8,$BA,$BC,$BE         ; LEVEL 4
        .BYTE   $C0,$C2,$C4,$C6,$C8,$CA,$CC,$CE
        .BYTE   $D0,$D2,$D4,$D6,$D8,$DA,$DC,$DE 
        .BYTE   $E0,$E2,$E4,$E6,$E8,$EA,$EC,$EE 
        .BYTE   $F0,$F2,$F4,$F6,$F8,$FA,$FC,$FE 
        .BYTE   $F0,$F2,$F4,$F6,$F8,$FA,$FC,$FE


random_gen:
        ldx #32          ; generate 4 bytes
@loop:        
        lda random4     ; random bit generator
        rol             ; written by kevtis
        rol             ; uses user input from joystick for initial values
        rol
        rol
        eor random4     ; this will XOR two bits together and put the answer in bit 7 of the acc
        rol             ; this puts the answer into the carry
        ror random1
        ror random2
        ror random3
        ror random4
        dex
        bne @loop
        rts



nmi:
	pha
	txa
	pha
	tya
	pha

        lda $2002
        ldy #0
;        sty $2001

	lda #$3F        ; write palette
	sta $2006
        sty $2006
        ldy #32
@write:
        lda pal-1, y 
	sta $2007
        dey
	bne @write

        lda melt
        bne @meltit

        inc scorething
        lda scorething
        cmp #1
        beq @normal
        lda #0
        sta scorething
        lda #$20
        sta $2006
        lda #$44
        sta $2006

        ldx #16
:
        lda topscore-1,x
        sta $2007
        dex
        bne :-
        beq @nomelt

@normal:
        lda #$20
        sta $2006
        lda #$6C
        sta $2006
        ldx #16
:
        lda score-1,x
        sta $2007
        dex
        bne :-
        beq @nomelt

@meltit:
        lda #$01
        sta $2006 ; zero
        lda #$58
        sta $2006

        lda melt
        cmp #2
        beq @endmelt

        ldx #8
:
        lda meltmem-1,x
        sta $2007
        dex
        bne :-
        beq @nomelt
@endmelt:
        ldx #8
        lda #$FF
:
        sta $2007
        dex
        bne :-
        stx melt


@nomelt:
        sty $2006
        sty $2006

        sty $2003       ; clear sprite ram address
        sty $2005       ; no scrolling
        lda scroll_v
        sta $2005



	lda joy1
	sta joy1old
        ldx     #$01    ;
        stx     $4016   ; reset strobe
	sty     $4016   ; clear strobe
	sty     joy1    ; clears joystick data
	ldy     #$08    ; do all 8 buttons
read_buttons:
	lda     $4016   ; load button status
	and     #$01    ; only keep lowest bit
	lsr     a       ; transfer to carry flag
	rol     joy1
	dey
	bne     read_buttons

        ldx #32
        lda #0
:
        sta $2E1-4,x
        dex
        dex
        dex
        dex
        bne :-

        lda lives
        beq @nolife
        asl
        asl
        tax
:
        lda #$15
        sta $2E1-4,x
        dex
        dex
        dex
        dex
        bne :-

@nolife:

        ldx #2
        stx $4014       ; set sprite DMA

        inc sync

        jsr random_gen

;        lda v2001
;        sta $2001

	pla
	tay
	pla
	tax
	pla
irq:
	rti


palette:
        .byte $20,$10,$00,$0F   ; white
        .byte $37,$26,$07,$0F   ; blue
        .byte $08,$2A,$1A,$0F   ; green
        .byte $26,$16,$06,$0F   ; red


packed_font:    .incbin "font.1bp"

rnc_graphics:   .incbin "food.chr"

back:   .incbin "title.cmp"

lifedisplay:    .byte $10,$1C,$28,$34,$40,$4C,$58,$64


play_sfx:
        lda sfx_index,x
        sta $4000,y
        lda sfx_index+1,x
        sta $4001,y
        lda sfx_index+2,x
        sta $4002,y
        lda sfx_index+3,x
        sta $4003,y
        rts


sfx_index:      .byte %10001000,%10111011,%1111100,%11111110
                .byte %11100000,%10010010,%1110000,%11111000


.asciiz "Program and Audiovisual Copyright 2003 J.A.Parsell II"



.segment "VECTORS"
	.addr nmi
        .addr start
	.addr irq
